package cz.muni.fi.pb162.music;

import java.util.ArrayList;
import java.util.Collection;
import java.util.Collections;
import java.util.Comparator;
import java.util.List;
import java.util.SortedSet;
import java.util.TreeSet;

public class AudioCD {
	
	private String name;
	
	private String author;
	
	private List<Song> songs = new ArrayList<Song>();
	
	public void writeSongs(Collection<Song> songs){
		this.songs.addAll(songs);
	}
	
	public Song getSong(int position){
		if(position < 0 || position >= songs.size()){
			throw new IllegalArgumentException("position must be at least 0 and" +
					" max length of the cd - 1");
		}
		return songs.get(position);
	}
	

	/**
	 * @return the name
	 */
	public String getName() {
		return name;
	}

	/**
	 * @param name the name to set
	 */
	public void setName(String name) {
		this.name = name;
	}

	/**
	 * @return the author
	 */
	public String getAuthor() {
		return author;
	}

	/**
	 * @param author the author to set
	 */
	public void setAuthor(String author) {
		this.author = author;
	}

	/**
	 * @return the songs
	 */
	public List<Song> getSongs() {
		Collections.sort(songs);
		return songs;
	}
	
	public SortedSet<Song> getSortedSongs(){
		return new TreeSet<Song>(songs);
	}
	
	public SortedSet<Song> getSortedByNameSongs(){
		SortedSet<Song> sortedSet = new TreeSet<Song>(new Comparator<Song>(){

			/* (non-Javadoc)
			 * @see java.util.Comparator#compare(java.lang.Object, java.lang.Object)
			 */
			@Override
			public int compare(Song arg0, Song arg1) {
				return arg0.getName().compareTo(arg1.getName());
			}
			
		});
		sortedSet.addAll(songs);
		return sortedSet;
	}
	

}
