package cz.muni.fi.pb162.radio;

import cz.muni.fi.pb162.radio.parts.*;

/**
 * Implementation of radio with same funcionality as RadioImpl, but using UniversalRadio. 
 * 
 * @author �ubo� Pecho 
 * @version 20.10.2009
 */
public class RadioImpl2 implements Radio
{
    private Radio delegate;
    
    public RadioImpl2(){
        delegate = new UniversalRadio(new Switch(), new Speaker(30), new Display());
    }
    
    /**
     * Constructor that creates new radio with its all parts
     * @param maxVolume the desired maximal volume of the radio
     */
    public RadioImpl2(int maxVolume){
        delegate = new UniversalRadio(new Switch(), new Speaker(maxVolume), new Display());
    }
    
    public void turnOn(){
            delegate.turnOn();
    }
    
    public void turnOff(){
            delegate.turnOff();
    }
    
    public void increaseVolume(){
            delegate.increaseVolume();
    }
    
    public void decreaseVolume(){
            delegate.decreaseVolume();
    }
    
    public void setFrequency(double frequency){
            delegate.setFrequency(frequency);
    }
    
    public void increaseFrequency(double frequency){
            delegate.increaseFrequency(frequency);
    }
    
    public void increaseFrequency(int frequency){
            delegate.increaseFrequency(frequency);
    }
    
    public void decreaseFrequency(double frequency){
            delegate.decreaseFrequency(frequency);
    }
    
    public void decreaseFrequency(int frequency){
            delegate.decreaseFrequency(frequency);
    }

    @Override
    public boolean equals(Object o) {
        if (this == o) return true;
        if (!(o instanceof RadioImpl2)) return false;

        RadioImpl2 that = (RadioImpl2) o;

        if (delegate != null ? !delegate.equals(that.delegate) : that.delegate != null) return false;

        return true;
    }

    @Override
    public int hashCode() {
        return delegate != null ? delegate.hashCode() : 0;
    }
}
