package cz.muni.fi.pb162.radio.parts;


/**
 * One line text display with 20 being the maximal number of characters
 *
 * @author �.ubo� Pecho, tomorrow@mail.muni.cz .
 * @version 8.10.2009
 */
public class Display implements Displayable {

    /**
     * Content of the display
     */
    private String content = "";

    /**
     * @return content of the display
     */
    public String getContent() {
        return content;
    }

    /**
     * Sets the content of the display. If the set content is longer then 20 characters,
     * the overflowed characters are ignored
     *
     * @param content
     */
    public void setContent(String content) {
        if (content == null) {
            throw new NullPointerException("content");
        }
        if(content.length()> 20 ){
            throw new IllegalArgumentException("length of content must be 20 at most");
        }
        this.content = content;
    }

    @Override
    public boolean equals(Object o) {
        if (this == o) return true;
        if (!(o instanceof Display)) return false;

        Display display = (Display) o;

        if (content != null ? !content.equals(display.content) : display.content != null) return false;

        return true;
    }

    @Override
    public int hashCode() {
        return content != null ? content.hashCode() : 0;
    }
}
