package cz.muni.fi.pb162.radio.parts;


/**
 * A speaker with ability to change the volume to change the volume to values
 * from zero up to maximal volume
 * 
 * @author �.ubo� Pecho, tomorrow@mail.muni.cz .
 * @version 8.10.2009
 */
public class Speaker implements GivingSound
{
    
    /**
     * Maximal volume of the speaker
     */
    private int maxVolume;
    
    /**
     * Actual volume of the speaker
     */
    private int volume = 0;
    
    /**
     * Constructor for speaker
     * @param maxVolume desired maximal volume of the speaker
     */
    public Speaker(int maxVolume){
        this.maxVolume = maxVolume;
    }
    
    /**
     * Set the volume of the speaker, if the value is out of range, it is ignored
     * @param volume
     */
    public void setVolume(int volume){
        if(volume >= 0 && volume <=maxVolume) {
            this.volume = volume;
        }
    }
    
    /**
     * @return the volume of the speaker
     */
    public int getVolume(){
        return volume;
    }

    @Override
    public boolean equals(Object o) {
        if (this == o) return true;
        if (!(o instanceof Speaker)) return false;

        Speaker speaker = (Speaker) o;

        if (maxVolume != speaker.maxVolume) return false;
        if (volume != speaker.volume) return false;

        return true;
    }

    @Override
    public int hashCode() {
        int result = maxVolume;
        result = 31 * result + volume;
        return result;
    }
}
